/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.modules.pl.product.controller;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import lombok.AllArgsConstructor;
import javax.validation.Valid;

import org.springblade.core.secure.BladeUser;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.secure.utils.AuthUtil;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.Func;
import org.springframework.web.bind.annotation.*;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springblade.modules.pl.product.entity.ProductEntity;
import org.springblade.modules.pl.product.vo.ProductVO;
import org.springblade.modules.pl.product.excel.ProductExcel;
import org.springblade.modules.pl.product.wrapper.ProductWrapper;
import org.springblade.modules.pl.product.service.IProductService;
import org.springblade.core.boot.ctrl.BladeController;
import org.springblade.core.tool.utils.DateUtil;
import org.springblade.core.excel.util.ExcelUtil;
import org.springblade.core.tool.constant.BladeConstant;
import springfox.documentation.annotations.ApiIgnore;
import java.util.Map;
import java.util.List;
import javax.servlet.http.HttpServletResponse;

/**
 * 产品表 控制器
 *
 * @author BladeX
 * @since 2023-12-05
 */
@RestController
@AllArgsConstructor
@RequestMapping("pl-product/product")
@Api(value = "产品表", tags = "产品表接口")
public class ProductController extends BladeController {

	private final IProductService productService;

	/**
	 * 产品表 详情
	 */
	@GetMapping("/detail")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入product")
	public R<ProductVO> detail(ProductEntity product) {
		ProductEntity detail = productService.getOne(Condition.getQueryWrapper(product));
		return R.data(ProductWrapper.build().entityVO(detail));
	}
	/**
	 * 产品表 分页
	 */
	@GetMapping("/list")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页", notes = "传入product")
	public R<IPage<ProductVO>> list(@ApiIgnore @RequestParam Map<String, Object> product, Query query) {
		query.setDescs("create_time");
		BladeUser user = AuthUtil.getUser();
		if(user.getUserCategory()==2){
			product.put("factory_id",user.getFactoryId());
		}
		String scanDateArr = null;
		String createTimeArr = null;
		if(product.get("scanDateArr")!=null){
			scanDateArr = (String) product.get("scanDateArr");
			product.remove("scanDateArr");
		}
		if(product.get("createTimeArr")!=null){
			createTimeArr = (String) product.get("createTimeArr");
			product.remove("createTimeArr");
		}
		QueryWrapper<ProductEntity> wrapper = Condition.getQueryWrapper(product, ProductEntity.class);
		if(scanDateArr!=null){
			String[]  scanDates  = scanDateArr.split(",");
			wrapper.lambda().ge(ProductEntity::getScanDate,scanDates[0]);
			wrapper.lambda().le(ProductEntity::getScanDate,scanDates[1]);
		}
		if(createTimeArr!=null){
			String[]  createTimes  = createTimeArr.split(",");
			wrapper.lambda().ge(ProductEntity::getCreateTime,createTimes[0]+" 00:00:00");
			wrapper.lambda().le(ProductEntity::getCreateTime,createTimes[1]+" 23:59:59");
		}
		IPage<ProductEntity> pages = productService.page(Condition.getPage(query),wrapper);
		return R.data(ProductWrapper.build().pageVO(pages));
	}

	/**
	 * 产品表 自定义分页
	 */
	@GetMapping("/page")
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分页", notes = "传入product")
	public R<IPage<ProductVO>> page(ProductVO product, Query query) {
		IPage<ProductVO> pages = productService.selectProductPage(Condition.getPage(query), product);
		return R.data(pages);
	}

	/**
	 * 产品表 新增
	 */
	@PostMapping("/save")
	@ApiOperationSupport(order = 4)
	@ApiOperation(value = "新增", notes = "传入product")
	public R save(@Valid @RequestBody ProductEntity product) {
		return R.status(productService.save(product));
	}

	/**
	 * 产品表 修改
	 */
	@PostMapping("/update")
	@ApiOperationSupport(order = 5)
	@ApiOperation(value = "修改", notes = "传入product")
	public R update(@Valid @RequestBody ProductEntity product) {
		return R.status(productService.updateById(product));
	}

	/**
	 * 产品表 新增或修改
	 */
	@PostMapping("/submit")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入product")
	public R submit(@Valid @RequestBody ProductEntity product) {
		BladeUser user = AuthUtil.getUser();
		if(user.getUserCategory()==2){
			product.setFactoryId(user.getFactoryId());
		}
		return R.status(productService.saveOrUpdate(product));
	}

	/**
	 * 产品表 删除
	 */
	@PostMapping("/remove")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	public R remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
		return R.status(productService.deleteLogic(Func.toLongList(ids)));
	}


	/**
	 * 导出数据
	 */
	@GetMapping("/export-product")
	@ApiOperationSupport(order = 9)
	@ApiOperation(value = "导出数据", notes = "传入product")
	public void exportProduct(@ApiIgnore @RequestParam Map<String, Object> product, BladeUser bladeUser, HttpServletResponse response) {
		BladeUser user = AuthUtil.getUser();
		if(user.getUserCategory()==2){
			product.put("factory_id",user.getFactoryId());
		}
		//if (!AuthUtil.isAdministrator()) {
		//	queryWrapper.lambda().eq(Product::getTenantId, bladeUser.getTenantId());
		//}


		String scanDateArr = null;
		String createTimeArr = null;
		if(product.get("scanDateArr")!=null){
			scanDateArr = (String) product.get("scanDateArr");
			product.remove("scanDateArr");
		}
		if(product.get("createTimeArr")!=null){
			createTimeArr = (String) product.get("createTimeArr");
			product.remove("createTimeArr");
		}
		QueryWrapper<ProductEntity> wrapper = Condition.getQueryWrapper(product, ProductEntity.class);
		if(scanDateArr!=null){
			String[]  scanDates  = scanDateArr.split(",");
			wrapper.lambda().ge(ProductEntity::getScanDate,scanDates[0]);
			wrapper.lambda().le(ProductEntity::getScanDate,scanDates[1]);
		}
		if(createTimeArr!=null){
			String[]  createTimes  = createTimeArr.split(",");
			wrapper.lambda().ge(ProductEntity::getCreateTime,createTimes[0]+" 00:00:00");
			wrapper.lambda().le(ProductEntity::getCreateTime,createTimes[1]+" 23:59:59");
		}
		wrapper.lambda().eq(ProductEntity::getIsDeleted, BladeConstant.DB_NOT_DELETED);;
		wrapper.orderByDesc("create_time");
		List<ProductExcel> list = productService.exportProduct(wrapper);
		ExcelUtil.export(response, "产品表数据" + DateUtil.time(), "产品表数据表", list, ProductExcel.class);
	}

}
